
package de.ivu.elect.presentation.wahl;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.wahl.boundary.WahlterminBoundaryCreate;
import de.ivu.elect.business.wahl.boundary.WahlterminFactory;
import de.ivu.elect.business.wahl.entity.Wahltermin;
import de.ivu.elect.business.wahl.entity.WahlterminMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractWahlterminCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractWahlterminCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.WAHLTERMIN_CREATE)
public abstract class AbstractWahlterminCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Wahltermin> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlterminCreateView";

  public static final String VIEW_ID = "/wahl/wahltermin-create.xhtml";

  public static final String PARENT_VIEW_ID = "/wahl/wahltermin-search.xhtml";

  @Inject
  protected transient WahlterminBoundaryCreate create;

  protected Wahltermin entity;

  @Inject
  protected transient WahlterminMeta entityMeta;

  
  @Inject
  protected transient WahlterminFactory factory;

  public AbstractWahlterminCreateNoScopeView() {
    super();
  }

  @PostConstruct
  public void init() {
    setEntity(factory.create());
  }

  

  public Wahltermin getEntity() {
    return entity;
  }

  protected void setEntity(Wahltermin entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.WAHLTERMIN_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Wahltermin entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Wahltermin entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.WAHLTERMIN_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
